#include<bits/stdc++.h>
using namespace std;
int main()
{

    int N,K,br=0,a;
    cin>>N>>K;
    long long chis[N];
    for(int i=0; i<N; i++)
    {
        cin>>chis[i];
    }
    for(int l=0; l<N; l++)
    {
        for(int r=l; r<N; r++)
        {
            a=0;
            for(int i=0; i<l-r+1; i++)
            {
                if(l-r+1==1)
                {
                    a=chis[l];
                }
                else
                {
                    if(i==0)
                    {
                        a=chis[l]|chis[l+1];
                    }else{
                    a=a|chis[l+i];

                    }
                }
            }
            if(a>=K)
            {
                br++;
                cout<<l<<" "<<r<<endl;
            }
        }
    }
    cout<<br;



    return 0;
}
